//+------------------------------------------------------------------+
//|                                                      BB_Diff.mq4 |
//|                                       Copyright  2006, Akuma99. |
//|                                    http://www.beginnertrader.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Akuma99."
#property link      "http://www.beginnertrader.com"

#property indicator_chart_window

extern double bbPeriod=20;
extern double bbDev=2.0;
extern string displayText="Bollinger Band Difference:";

int start() {

   int    counted_bars=IndicatorCounted();
   
   double upperBand = iBands(NULL,0,bbPeriod,bbDev,0,PRICE_CLOSE,MODE_UPPER,0);
   double lowerBand = iBands(NULL,0,bbPeriod,bbDev,0,PRICE_CLOSE,MODE_LOWER,0);
   
   double bandDifference = upperBand-lowerBand;
   
   Comment("\n",displayText," ", bandDifference, " (", bandDifference/Point," Pips)");
   
   return(0);

}

